# QwtPicker Class Reference

QwtPicker provides selections on a widget. More...

`#include <qwt_picker.h>`

Inheritance diagram for QwtPicker:
[legend]

List of all members.

## Public Types

enum | DisplayMode { AlwaysOff, AlwaysOn, ActiveOnly }
enum | KeyPatternCode { KeySelect1, KeySelect2, KeyAbort, KeyLeft, KeyRight, KeyUp, KeyDown, KeyRedo, KeyUndo, KeyHome, KeyPatternCount }
enum | MousePatternCode { MouseSelect1, MouseSelect2, MouseSelect3, MouseSelect4, MouseSelect5, MouseSelect6, MousePatternCount }
enum | ResizeMode { Stretch, KeepSize }
enum | RubberBand { NoRubberBand = 0, HLineRubberBand, VLineRubberBand, CrossRubberBand, RectRubberBand, EllipseRubberBand, PolygonRubberBand, UserRubberBand = 100 }

## Public Slots

void | setEnabled (bool)

## Signals

void | activated (bool on)
void | appended (const QPoint &pos)
void | changed (const QPolygon &selection)
void | moved (const QPoint &pos)
void | removed (const QPoint &pos)
void | selected (const QPolygon &polygon)

## Public Member Functions

virtual void | drawRubberBand (QPainter *) const
virtual void | drawTracker (QPainter *) const
virtual bool | eventFilter (QObject *, QEvent *)
void | initKeyPattern ()
void | initMousePattern (int numButtons)
bool | isActive () const
bool | isEnabled () const
bool | keyMatch (uint pattern, const QKeyEvent *) const
const QVector< KeyPattern > & | keyPattern () const
QVector< KeyPattern > & | keyPattern ()
bool | mouseMatch (uint pattern, const QMouseEvent *) const
const QVector< MousePattern > & | mousePattern () const
QVector< MousePattern > & | mousePattern ()
QWidget * | parentWidget ()
const QWidget * | parentWidget () const
virtual QRect | pickRect () const
| QwtPicker (RubberBand rubberBand, DisplayMode trackerMode, QWidget *)
| QwtPicker (QWidget *parent)
ResizeMode | resizeMode () const
RubberBand | rubberBand () const
QPen | rubberBandPen () const
QPolygon | selection () const
void | setKeyPattern (uint pattern, int key, int state=Qt::NoButton)
void | setKeyPattern (const QVector< KeyPattern > &)
void | setMousePattern (uint pattern, int button, int state=Qt::NoButton)
void | setMousePattern (const QVector< MousePattern > &)
void | setResizeMode (ResizeMode)
void | setRubberBand (RubberBand)
void | setRubberBandPen (const QPen &)
void | setStateMachine (QwtPickerMachine *)
void | setTrackerFont (const QFont &)
void | setTrackerMode (DisplayMode)
void | setTrackerPen (const QPen &)
const QwtPickerMachine * | stateMachine () const
QwtPickerMachine * | stateMachine ()
QFont | trackerFont () const
DisplayMode | trackerMode () const
QPen | trackerPen () const
QPoint | trackerPosition () const
virtual QRect | trackerRect (const QFont &) const
virtual QwtText | trackerText (const QPoint &pos) const
virtual | ~QwtPicker ()

## Protected Member Functions

virtual bool | accept (QPolygon &) const
virtual QPolygon | adjustedPoints (const QPolygon &) const
virtual void | append (const QPoint &)
virtual void | begin ()
virtual bool | end (bool ok=true)
virtual bool | keyMatch (const KeyPattern &, const QKeyEvent *) const
virtual bool | mouseMatch (const MousePattern &, const QMouseEvent *) const
virtual void | move (const QPoint &)
const QPolygon & | pickedPoints () const
virtual void | remove ()
virtual void | reset ()
const QWidget * | rubberBandWidget () const
virtual void | stretchSelection (const QSize &oldSize, const QSize &newSize)
const QWidget * | trackerWidget () const
virtual void | transition (const QEvent *)
virtual void | updateDisplay ()
virtual void | widgetEnterEvent (QEvent *)
virtual void | widgetKeyPressEvent (QKeyEvent *)
virtual void | widgetKeyReleaseEvent (QKeyEvent *)
virtual void | widgetLeaveEvent (QEvent *)
virtual void | widgetMouseDoubleClickEvent (QMouseEvent *)
virtual void | widgetMouseMoveEvent (QMouseEvent *)
virtual void | widgetMousePressEvent (QMouseEvent *)
virtual void | widgetMouseReleaseEvent (QMouseEvent *)
virtual void | widgetWheelEvent (QWheelEvent *)

## Detailed Description

QwtPicker provides selections on a widget.

QwtPicker filters all enter, leave, mouse and keyboard events of a widget and translates them into an array of selected points.

The way how the points are collected depends on type of state machine that is connected to the picker. Qwt offers a couple of predefined state machines for selecting:

- Nothing
  QwtPickerTrackerMachine
- Single points
  QwtPickerClickPointMachine, QwtPickerDragPointMachine
- Rectangles
  QwtPickerClickRectMachine, QwtPickerDragRectMachine
- Polygons
  QwtPickerPolygonMachine

While these state machines cover the most common ways to collect points it is also possible to implement individual machines as well.

QwtPicker translates the picked points into a selection using the adjustedPoints method. adjustedPoints is intended to be reimplemented to fixup the selection according to application specific requirements. (F.e. when an application accepts rectangles of a fixed aspect ratio only.)

Optionally QwtPicker support the process of collecting points by a rubberband and tracker displaying a text for the current mouse position.

Example

      #include <qwt_picker.h>
      #include <qwt_picker_machine.h>

      QwtPicker *picker = new QwtPicker(widget);
      picker->setStateMachine(new QwtPickerDragRectMachine);
      picker->setTrackerMode(QwtPicker::ActiveOnly);
      picker->setRubberBand(QwtPicker::RectRubberBand);

The state machine triggers the following commands:

- begin()
  Activate/Initialize the selection.
- append()
  Add a new point
- move()
  Change the position of the last point.
- remove()
  Remove the last point.
- end()
  Terminate the selection and call accept to validate the picked points.

The picker is active (isActive()), between begin() and end(). In active state the rubberband is displayed, and the tracker is visible in case of trackerMode is ActiveOnly or AlwaysOn.

The cursor can be moved using the arrow keys. All selections can be aborted using the abort key. (QwtEventPattern::KeyPatternCode)

Warning:
  In case of QWidget::NoFocus the focus policy of the observed widget is set to QWidget::WheelFocus and mouse tracking will be manipulated while the picker is active, or if trackerMode() is AlwayOn.

## Member Enumeration Documentation

enum QwtPicker::DisplayMode

Display mode.

See also:
  setTrackerMode(), trackerMode(), isActive()

Enumerator:

  AlwaysOff | Display never.
  AlwaysOn | Display always.
  ActiveOnly | Display only when the selection is active.

enum QwtEventPattern::KeyPatternCode`[inherited]`

Symbolic keyboard input codes.

Default initialization:

- KeySelect1
  Qt::Key_Return
- KeySelect2
  Qt::Key_Space
- KeyAbort
  Qt::Key_Escape

- KeyLeft
  Qt::Key_Left
- KeyRight
  Qt::Key_Right
- KeyUp
  Qt::Key_Up
- KeyDown
  Qt::Key_Down

- KeyUndo
  Qt::Key_Minus
- KeyRedo
  Qt::Key_Plus
- KeyHome
  Qt::Key_Escape

enum QwtEventPattern::MousePatternCode`[inherited]`

Symbolic mouse input codes.

The default initialization for 3 button mice is:

- MouseSelect1
  Qt::LeftButton
- MouseSelect2
  Qt::RightButton
- MouseSelect3
  Qt::MidButton
- MouseSelect4
  Qt::LeftButton + Qt::ShiftButton
- MouseSelect5
  Qt::RightButton + Qt::ShiftButton
- MouseSelect6
  Qt::MidButton + Qt::ShiftButton

The default initialization for 2 button mice is:

- MouseSelect1
  Qt::LeftButton
- MouseSelect2
  Qt::RightButton
- MouseSelect3
  Qt::LeftButton + Qt::AltButton
- MouseSelect4
  Qt::LeftButton + Qt::ShiftButton
- MouseSelect5
  Qt::RightButton + Qt::ShiftButton
- MouseSelect6
  Qt::LeftButton + Qt::AltButton + Qt::ShiftButton

The default initialization for 1 button mice is:

- MouseSelect1
  Qt::LeftButton
- MouseSelect2
  Qt::LeftButton + Qt::ControlButton
- MouseSelect3
  Qt::LeftButton + Qt::AltButton
- MouseSelect4
  Qt::LeftButton + Qt::ShiftButton
- MouseSelect5
  Qt::LeftButton + Qt::ControlButton + Qt::ShiftButton
- MouseSelect6
  Qt::LeftButton + Qt::AltButton + Qt::ShiftButton

See also:
  initMousePattern()

enum QwtPicker::ResizeMode

Controls what to do with the selected points of an active selection when the observed widget is resized.

The default value is QwtPicker::Stretch.

See also:
  setResizeMode()

Enumerator:

  Stretch | All points are scaled according to the new size,.
  KeepSize | All points remain unchanged.

enum QwtPicker::RubberBand

Rubberband style

The default value is QwtPicker::NoRubberBand.

See also:
  setRubberBand(), rubberBand()

Enumerator:

  NoRubberBand | No rubberband.
  HLineRubberBand | A horizontal line ( only for QwtPicker::PointSelection )
  VLineRubberBand | A vertical line ( only for QwtPicker::PointSelection )
  CrossRubberBand | A crosshair ( only for QwtPicker::PointSelection )
  RectRubberBand | A rectangle ( only for QwtPicker::RectSelection )
  EllipseRubberBand | An ellipse ( only for QwtPicker::RectSelection )
  PolygonRubberBand | A polygon ( only for QwtPicker::&PolygonSelection )
  UserRubberBand | Values >= UserRubberBand can be used to define additional rubber bands.

## Constructor & Destructor Documentation

QwtPicker::QwtPicker | ( | QWidget * | parent | ) | `[explicit]`

Constructor

Creates an picker that is enabled, but without a state machine. rubberband and tracker are disabled.

Parameters:

  parent | Parent widget, that will be observed

QwtPicker::QwtPicker | ( | RubberBand | rubberBand,
|  | DisplayMode | trackerMode,
|  | QWidget * | parent
| ) |  | `[explicit]`

Constructor

Parameters:

  rubberBand | Rubberband style
  trackerMode | Tracker mode
  parent | Parent widget, that will be observed

QwtPicker::~QwtPicker | ( |  | ) | `[virtual]`

Destructor.

## Member Function Documentation

bool QwtPicker::accept | ( | QPolygon & | selection | ) | const`[protected, virtual]`

Validate and fixup the selection.

Accepts all selections unmodified

Parameters:

  selection | Selection to validate and fixup

Returns:
  true, when accepted, false otherwise

Reimplemented in QwtPlotZoomer.

void QwtPicker::activated | ( | bool | on | ) | `[signal]`

A signal indicating, when the picker has been activated. Together with setEnabled() it can be used to implement selections with more than one picker.

Parameters:

  on | True, when the picker has been activated

QPolygon QwtPicker::adjustedPoints | ( | const QPolygon & | points | ) | const`[protected, virtual]`

Map the pickedPoints() into a selection()

adjustedPoints() maps the points, that have been collected on the parentWidget() into a selection(). The default implementation simply returns the points unmodified.

The reason, why a selection() differs from the picked points depends on the application requirements. F.e. :

- A rectangular selection might need to have a specific aspect ratio only.
- A selection could accept non intersecting polygons only.
- ...

The example below is for a rectangular selection, where the first point is the center of the selected rectangle.

Example

      QPolygon MyPicker::adjustedPoints(const QPolygon &points) const
      {
          QPolygon adjusted;
          if ( points.size() == 2 )
          {
              const int width = qAbs(points[1].x() - points[0].x());
              const int height = qAbs(points[1].y() - points[0].y());

              QRect rect(0, 0, 2 * width, 2 * height);
              rect.moveCenter(points[0]);

              adjusted += rect.topLeft();
              adjusted += rect.bottomRight();
          }
          return adjusted;
      }

void QwtPicker::append | ( | const QPoint & | pos | ) | `[protected, virtual]`

Append a point to the selection and update rubberband and tracker. The appended() signal is emitted.

Parameters:

  pos | Additional point

See also:
  isActive(), begin(), end(), move(), appended()

Reimplemented in QwtPlotPicker.

void QwtPicker::appended | ( | const QPoint & | pos | ) | `[signal]`

A signal emitted when a point has been appended to the selection

Parameters:

  pos | Position of the appended point.

See also:
  append(). moved()

void QwtPicker::begin | ( |  | ) | `[protected, virtual]`

Open a selection setting the state to active

See also:
  isActive(), end(), append(), move()

Reimplemented in QwtPlotZoomer.

void QwtPicker::changed | ( | const QPolygon & | selection | ) | `[signal]`

A signal emitted when the active selection has been changed. This might happen when the observed widget is resized.

Parameters:

  selection | Changed selection

See also:
  stretchSelection()

void QwtPicker::drawRubberBand | ( | QPainter * | painter | ) | const`[virtual]`

Draw a rubberband, depending on rubberBand()

Parameters:

  painter | Painter, initialized with clip rect

See also:
  rubberBand(), RubberBand

void QwtPicker::drawTracker | ( | QPainter * | painter | ) | const`[virtual]`

Draw the tracker

Parameters:

  painter | Painter

See also:
  trackerRect(), trackerText()

bool QwtPicker::end | ( | bool | ok = `true` | ) | `[protected, virtual]`

Close a selection setting the state to inactive.

The selection is validated and maybe fixed by accept().

Parameters:

  ok | If true, complete the selection and emit a selected signal otherwise discard the selection.

Returns:
  true if the selection is accepted, false otherwise

See also:
  isActive(), begin(), append(), move(), selected(), accept()

Reimplemented in QwtPlotPicker, and QwtPlotZoomer.

bool QwtPicker::eventFilter | ( | QObject * | object,
|  | QEvent * | event
| ) |  | `[virtual]`

Event filter.

When isEnabled() == true all events of the observed widget are filtered. Mouse and keyboard events are translated into widgetMouse- and widgetKey- and widgetWheel-events. Paint and Resize events are handled to keep rubberband and tracker up to date.

Parameters:

  object | Object to be filtered
  event | Event

See also:
  widgetEnterEvent(), widgetLeaveEvent(), widgetMousePressEvent(), widgetMouseReleaseEvent(), widgetMouseDoubleClickEvent(), widgetMouseMoveEvent(), widgetWheelEvent(), widgetKeyPressEvent(), widgetKeyReleaseEvent(), QObject::installEventFilter(), QObject::event()

void QwtEventPattern::initKeyPattern | ( |  | ) | `[inherited]`

Set default mouse patterns.

See also:
  KeyPatternCode

void QwtEventPattern::initMousePattern | ( | int | numButtons | ) | `[inherited]`

Set default mouse patterns, depending on the number of mouse buttons

Parameters:

  numButtons | Number of mouse buttons ( <= 3 )

See also:
  MousePatternCode

bool QwtPicker::isActive | ( |  | ) | const

A picker is active between begin() and end().

Returns:
  true if the selection is active.

bool QwtPicker::isEnabled | ( |  | ) | const

Returns:
  true when enabled, false otherwise

See also:
  setEnabled(), eventFilter()

bool QwtEventPattern::keyMatch | ( | uint | pattern,
|  | const QKeyEvent * | event
| ) |  | const`[inherited]`

Compare a key event with an event pattern.

A key event matches the pattern when both have the same key value and in the state value the same key flags (Qt::KeyButtonMask) are set.

Parameters:

  pattern | Index of the event pattern
  event | Key event

Returns:
  true if matches

See also:
  mouseMatch()

bool QwtEventPattern::keyMatch | ( | const KeyPattern & | pattern,
|  | const QKeyEvent * | event
| ) |  | const`[protected, virtual, inherited]`

Compare a key event with an event pattern.

A key event matches the pattern when both have the same key value and in the state value the same key flags (Qt::KeyButtonMask) are set.

Parameters:

  pattern | Key event pattern
  event | Key event

Returns:
  true if matches

See also:
  mouseMatch()

const QVector< QwtEventPattern::KeyPattern > & QwtEventPattern::keyPattern | ( |  | ) | const`[inherited]`

Return key patterns.

QVector< QwtEventPattern::KeyPattern > & QwtEventPattern::keyPattern | ( |  | ) | `[inherited]`

Return Key patterns.

bool QwtEventPattern::mouseMatch | ( | uint | pattern,
|  | const QMouseEvent * | event
| ) |  | const`[inherited]`

Compare a mouse event with an event pattern.

A mouse event matches the pattern when both have the same button value and in the state value the same key flags(Qt::KeyButtonMask) are set.

Parameters:

  pattern | Index of the event pattern
  event | Mouse event

Returns:
  true if matches

See also:
  keyMatch()

bool QwtEventPattern::mouseMatch | ( | const MousePattern & | pattern,
|  | const QMouseEvent * | event
| ) |  | const`[protected, virtual, inherited]`

Compare a mouse event with an event pattern.

A mouse event matches the pattern when both have the same button value and in the state value the same key flags(Qt::KeyButtonMask) are set.

Parameters:

  pattern | Mouse event pattern
  event | Mouse event

Returns:
  true if matches

See also:
  keyMatch()

QVector< QwtEventPattern::MousePattern > & QwtEventPattern::mousePattern | ( |  | ) | `[inherited]`

Return ,ouse patterns.

const QVector< QwtEventPattern::MousePattern > & QwtEventPattern::mousePattern | ( |  | ) | const`[inherited]`

Return mouse patterns.

void QwtPicker::move | ( | const QPoint & | pos | ) | `[protected, virtual]`

Move the last point of the selection The moved() signal is emitted.

Parameters:

  pos | New position

See also:
  isActive(), begin(), end(), append()

Reimplemented in QwtPlotPicker.

void QwtPicker::moved | ( | const QPoint & | pos | ) | `[signal]`

A signal emitted whenever the last appended point of the selection has been moved.

Parameters:

  pos | Position of the moved last point of the selection.

See also:
  move(), appended()

QWidget * QwtPicker::parentWidget | ( |  | ) |

Return the parent widget, where the selection happens.

const QWidget * QwtPicker::parentWidget | ( |  | ) | const

Return the parent widget, where the selection happens.

const QPolygon & QwtPicker::pickedPoints | ( |  | ) | const`[protected]`

Return the points, that have been collected so far. The selection() is calculated from the pickedPoints() in adjustedPoints().

Returns:
  Picked points

QRect QwtPicker::pickRect | ( |  | ) | const`[virtual]`

Find the area of the observed widget, where selection might happen.

Returns:
  parentWidget()->contentsRect()

void QwtPicker::remove | ( |  | ) | `[protected, virtual]`

Remove the last point of the selection The removed() signal is emitted.

See also:
  isActive(), begin(), end(), append(), move()

void QwtPicker::removed | ( | const QPoint & | pos | ) | `[signal]`

A signal emitted whenever the last appended point of the selection has been removed.

See also:
  remove(), appended()

void QwtPicker::reset | ( |  | ) | `[protected, virtual]`

Reset the state machine and terminate (end(false)) the selection

QwtPicker::ResizeMode QwtPicker::resizeMode | ( |  | ) | const

Returns:
  Resize mode

See also:
  setResizeMode(), ResizeMode

QwtPicker::RubberBand QwtPicker::rubberBand | ( |  | ) | const

Returns:
  Rubberband style

See also:
  setRubberBand(), RubberBand, rubberBandPen()

QPen QwtPicker::rubberBandPen | ( |  | ) | const

Returns:
  Rubberband pen

See also:
  setRubberBandPen(), rubberBand()

const QWidget * QwtPicker::rubberBandWidget | ( |  | ) | const`[protected]`

Returns:
  Widget displaying the rubberband

void QwtPicker::selected | ( | const QPolygon & | polygon | ) | `[signal]`

A signal emitting the selected points, at the end of a selection.

Parameters:

  polygon | Selected points

QPolygon QwtPicker::selection | ( |  | ) | const

Returns:
  Selected points

See also:
  pickedPoints(), adjustedPoints()

void QwtPicker::setEnabled | ( | bool | enabled | ) | `[slot]`

En/disable the picker.

When enabled is true an event filter is installed for the observed widget, otherwise the event filter is removed.

Parameters:

  enabled | true or false

See also:
  isEnabled(), eventFilter()

void QwtEventPattern::setKeyPattern | ( | uint | pattern,
|  | int | key,
|  | int | state = `Qt::NoButton`
| ) |  | `[inherited]`

Change one key pattern

Parameters:

  pattern | Index of the pattern
  key | Key
  state | State

See also:
  QKeyEvent

void QwtEventPattern::setKeyPattern | ( | const QVector< KeyPattern > & | pattern | ) | `[inherited]`

Change the key event patterns.

void QwtEventPattern::setMousePattern | ( | const QVector< MousePattern > & | pattern | ) | `[inherited]`

Change the mouse event patterns.

void QwtEventPattern::setMousePattern | ( | uint | pattern,
|  | int | button,
|  | int | state = `Qt::NoButton`
| ) |  | `[inherited]`

Change one mouse pattern

Parameters:

  pattern | Index of the pattern
  button | Button
  state | State

See also:
  QMouseEvent

void QwtPicker::setResizeMode | ( | ResizeMode | mode | ) |

Set the resize mode.

The resize mode controls what to do with the selected points of an active selection when the observed widget is resized.

Stretch means the points are scaled according to the new size, KeepSize means the points remain unchanged.

The default mode is Stretch.

Parameters:

  mode | Resize mode

See also:
  resizeMode(), ResizeMode

void QwtPicker::setRubberBand | ( | RubberBand | rubberBand | ) |

Set the rubberband style

Parameters:

  rubberBand | Rubberband style The default value is NoRubberBand.

See also:
  rubberBand(), RubberBand, setRubberBandPen()

void QwtPicker::setRubberBandPen | ( | const QPen & | pen | ) |

Set the pen for the rubberband

Parameters:

  pen | Rubberband pen

See also:
  rubberBandPen(), setRubberBand()

void QwtPicker::setStateMachine | ( | QwtPickerMachine * | stateMachine | ) |

Set a state machine and delete the previous one

Parameters:

  stateMachine | State machine

See also:
  stateMachine()

void QwtPicker::setTrackerFont | ( | const QFont & | font | ) |

Set the font for the tracker

Parameters:

  font | Tracker font

See also:
  trackerFont(), setTrackerMode(), setTrackerPen()

void QwtPicker::setTrackerMode | ( | DisplayMode | mode | ) |

Set the display mode of the tracker.

A tracker displays information about current position of the cursor as a string. The display mode controls if the tracker has to be displayed whenever the observed widget has focus and cursor (AlwaysOn), never (AlwaysOff), or only when the selection is active (ActiveOnly).

Parameters:

  mode | Tracker display mode

Warning:
  In case of AlwaysOn, mouseTracking will be enabled for the observed widget.

See also:
  trackerMode(), DisplayMode

void QwtPicker::setTrackerPen | ( | const QPen & | pen | ) |

Set the pen for the tracker

Parameters:

  pen | Tracker pen

See also:
  trackerPen(), setTrackerMode(), setTrackerFont()

const QwtPickerMachine * QwtPicker::stateMachine | ( |  | ) | const

Returns:
  Assigned state machine

See also:
  setStateMachine()

QwtPickerMachine * QwtPicker::stateMachine | ( |  | ) |

Returns:
  Assigned state machine

See also:
  setStateMachine()

void QwtPicker::stretchSelection | ( | const QSize & | oldSize,
|  | const QSize & | newSize
| ) |  | `[protected, virtual]`

Scale the selection by the ratios of oldSize and newSize The changed() signal is emitted.

Parameters:

  oldSize | Previous size
  newSize | Current size

See also:
  ResizeMode, setResizeMode(), resizeMode()

QFont QwtPicker::trackerFont | ( |  | ) | const

Returns:
  Tracker font

See also:
  setTrackerFont(), trackerMode(), trackerPen()

QwtPicker::DisplayMode QwtPicker::trackerMode | ( |  | ) | const

Returns:
  Tracker display mode

See also:
  setTrackerMode(), DisplayMode

QPen QwtPicker::trackerPen | ( |  | ) | const

Returns:
  Tracker pen

See also:
  setTrackerPen(), trackerMode(), trackerFont()

QPoint QwtPicker::trackerPosition | ( |  | ) | const

Returns:
  Current position of the tracker

QRect QwtPicker::trackerRect | ( | const QFont & | font | ) | const`[virtual]`

Calculate the bounding rectangle for the tracker text from the current position of the tracker

Parameters:

  font | Font of the tracker text

Returns:
  Bounding rectangle of the tracker text

See also:
  trackerPosition()

QwtText QwtPicker::trackerText | ( | const QPoint & | pos | ) | const`[virtual]`

Return the label for a position.

In case of HLineRubberBand the label is the value of the y position, in case of VLineRubberBand the value of the x position. Otherwise the label contains x and y position separated by a ',' .

The format for the string conversion is "%d".

Parameters:

  pos | Position

Returns:
  Converted position as string

Reimplemented in QwtPlotPicker.

const QWidget * QwtPicker::trackerWidget | ( |  | ) | const`[protected]`

Returns:
  Widget displaying the tracker text

void QwtPicker::transition | ( | const QEvent * | event | ) | `[protected, virtual]`

Passes an event to the state machine and executes the resulting commands. Append and Move commands use the current position of the cursor (QCursor::pos()).

Parameters:

  event | Event

void QwtPicker::updateDisplay | ( |  | ) | `[protected, virtual]`

Update the state of rubberband and tracker label.

void QwtPicker::widgetEnterEvent | ( | QEvent * | event | ) | `[protected, virtual]`

Handle a enter event for the observed widget.

Parameters:

  event | Qt event

See also:
  eventFilter(), widgetMousePressEvent(), widgetMouseReleaseEvent(), widgetMouseDoubleClickEvent(), widgetWheelEvent(), widgetKeyPressEvent(), widgetKeyReleaseEvent()

void QwtPicker::widgetKeyPressEvent | ( | QKeyEvent * | keyEvent | ) | `[protected, virtual]`

Handle a key press event for the observed widget.

Selections can be completely done by the keyboard. The arrow keys move the cursor, the abort key aborts a selection. All other keys are handled by the current state machine.

Parameters:

  keyEvent | Key event

See also:
  eventFilter(), widgetMousePressEvent(), widgetMouseReleaseEvent(), widgetMouseDoubleClickEvent(), widgetMouseMoveEvent(), widgetWheelEvent(), widgetKeyReleaseEvent(), stateMachine(), QwtEventPattern::KeyPatternCode

Reimplemented in QwtPlotZoomer.

void QwtPicker::widgetKeyReleaseEvent | ( | QKeyEvent * | keyEvent | ) | `[protected, virtual]`

Handle a key release event for the observed widget.

Passes the event to the state machine.

Parameters:

  keyEvent | Key event

See also:
  eventFilter(), widgetMousePressEvent(), widgetMouseReleaseEvent(), widgetMouseDoubleClickEvent(), widgetMouseMoveEvent(), widgetWheelEvent(), widgetKeyPressEvent(), stateMachine()

void QwtPicker::widgetLeaveEvent | ( | QEvent * | event | ) | `[protected, virtual]`

Handle a leave event for the observed widget.

Parameters:

  event | Qt event

See also:
  eventFilter(), widgetMousePressEvent(), widgetMouseReleaseEvent(), widgetMouseDoubleClickEvent(), widgetWheelEvent(), widgetKeyPressEvent(), widgetKeyReleaseEvent()

void QwtPicker::widgetMouseDoubleClickEvent | ( | QMouseEvent * | mouseEvent | ) | `[protected, virtual]`

Handle mouse double click event for the observed widget.

Parameters:

  mouseEvent | Mouse event

See also:
  eventFilter(), widgetMousePressEvent(), widgetMouseReleaseEvent(), widgetMouseMoveEvent(), widgetWheelEvent(), widgetKeyPressEvent(), widgetKeyReleaseEvent()

void QwtPicker::widgetMouseMoveEvent | ( | QMouseEvent * | mouseEvent | ) | `[protected, virtual]`

Handle a mouse move event for the observed widget.

Parameters:

  mouseEvent | Mouse event

See also:
  eventFilter(), widgetMousePressEvent(), widgetMouseReleaseEvent(), widgetMouseDoubleClickEvent(), widgetWheelEvent(), widgetKeyPressEvent(), widgetKeyReleaseEvent()

void QwtPicker::widgetMousePressEvent | ( | QMouseEvent * | mouseEvent | ) | `[protected, virtual]`

Handle a mouse press event for the observed widget.

Parameters:

  mouseEvent | Mouse event

See also:
  eventFilter(), widgetMouseReleaseEvent(), widgetMouseDoubleClickEvent(), widgetMouseMoveEvent(), widgetWheelEvent(), widgetKeyPressEvent(), widgetKeyReleaseEvent()

void QwtPicker::widgetMouseReleaseEvent | ( | QMouseEvent * | mouseEvent | ) | `[protected, virtual]`

Handle a mouse relase event for the observed widget.

Parameters:

  mouseEvent | Mouse event

See also:
  eventFilter(), widgetMousePressEvent(), widgetMouseDoubleClickEvent(), widgetMouseMoveEvent(), widgetWheelEvent(), widgetKeyPressEvent(), widgetKeyReleaseEvent()

Reimplemented in QwtPlotZoomer.

void QwtPicker::widgetWheelEvent | ( | QWheelEvent * | wheelEvent | ) | `[protected, virtual]`

Handle a wheel event for the observed widget.

Move the last point of the selection in case of isActive() == true

Parameters:

  wheelEvent | Wheel event

See also:
  eventFilter(), widgetMousePressEvent(), widgetMouseReleaseEvent(), widgetMouseDoubleClickEvent(), widgetMouseMoveEvent(), widgetKeyPressEvent(), widgetKeyReleaseEvent()